# Generated from deconstructable-0.1.0.gem by gem2rpm -*- rpm-spec -*-
%global gem_name deconstructable

Name: rubygem-%{gem_name}
Version: 0.1.0
Release: 1%{?dist}
Summary: Mixin to help implement deconstructable types
License: MIT
URL: https://rubygems.org/gems/deconstructable
Source0: https://rubygems.org/gems/%{gem_name}-%{version}.gem
BuildRequires: ruby(release)
BuildRequires: rubygems-devel
BuildRequires: ruby >= 2.7.0
# BuildRequires: rubygem(rspec) >= 3.2
# BuildRequires: rubygem(rspec) < 4
BuildArch: noarch

%description
This gem provides Deconstructable, a mixin module that helps you to support
pattern-matching over your types.
Usage
--------
```
class Thing
include Deconstructable
...
deconstructable :x, :y
deconstructable def foo
do_the_foo
end
end
```
This class provides a single DSL method `deconstructable` which helps you to
mark
methods and attributes as deconstructable. Deconstructable attributes will be
made
available in pattern matching, e.g.:
```
thing in Thing(foo:, x: 100, y:)
```
Classes that include `Deconstructable` gain an implementation of
`deconstruct_keys` that permits
hash-style key based pattern matching. Positional array-style patterns are not
supported.


%package doc
Summary: Documentation for %{name}
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description doc
Documentation for %{name}.

%prep
%setup -q -n %{gem_name}-%{version}

%build
# Create the gem as gem install only works on a gem file
gem build ../%{gem_name}-%{version}.gemspec

# %%gem_install compiles any C extensions and installs the gem into ./%%gem_dir
# by default, so that we can move it into the buildroot in %%install
%gem_install

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/



%check
pushd .%{gem_instdir}
# rspec spec
popd

%files
%dir %{gem_instdir}
%exclude %{gem_instdir}/.gitignore
%{gem_instdir}/.gitlab-ci.yml
%exclude %{gem_instdir}/.rubocop.yml
%{gem_instdir}/.tool-versions
%{gem_instdir}/CODE_OF_CONDUCT.md
%license %{gem_instdir}/LICENSE.txt
%{gem_instdir}/bin
%{gem_libdir}
%exclude %{gem_cache}
%{gem_spec}

%files doc
%doc %{gem_docdir}
%exclude %{gem_instdir}/.rspec
%{gem_instdir}/Gemfile
%{gem_instdir}/Gemfile.lock
%doc %{gem_instdir}/README.md
%{gem_instdir}/Rakefile
%{gem_instdir}/deconstructable.gemspec

%changelog
* Mon Sep 13 2021 mockbuilder - 0.1.0-1
- Initial package
